/*
_____________________________________________________________________________________
                   I N T R O D U C T I O N   T O   S T R U C T S
                                           Ron Kessler
                                      Created 1/23/2017

CLR Console Version
Run with F5

As we have seen with the native code version, structs are really User-defined types.

In this app I have grouped employee information into a new structure that lets me
handle several related attributes of employees.

I also use two helper methods to replace most of the Console::Write() and Console::ReadLine() statements.

_________________________________________________________________________________________
*/
#include "stdafx.h"

using namespace System;

void ShowPrompt (String^);			// helper method to display prompts
double get$ ();								// helper method to get payrate/hours


//---define my new data structure here
ref struct PayRoll			//tell CLR this is a reference type			
	{
		int empNumber;			// Employee number
		String^ name;				// Employee's name
		double hours;				// Hours worked
		double payRate;			// Hourly payRate
		double grossPay;		// Gross Pay
	};


int main(array<System::String ^> ^args)
{

	

	PayRoll employee; // employee is a PayRoll structure so create it here.

					  //---Option: you can initialize your struct just like an array if you like
					  //employee = {150, "Betty Ross", 40, 18.75 };


					  // Get the employee's number.
	ShowPrompt( "Enter the employee's number: ");
	employee.empNumber = Convert::ToInt32(Console::ReadLine());

	// Get the employee's name.
	ShowPrompt( "Enter the employee's name: ");
	employee.name = Console::ReadLine ();

	// Get the hours worked by the employee.
	ShowPrompt( "How many hours did the employee work? ");
	employee.hours = get$();

	// Get the employee's hourly pay rate.
	ShowPrompt( "What is the employee's hourly payRate? ");
	employee.payRate = get$();

	// Calculate the employee's gross pay.
	employee.grossPay = employee.hours * employee.payRate;

	// Display the employee data.
	ShowPrompt( "\n\n\nHere is the employee's payroll data:\n");
	ShowPrompt( "Name: " + employee.name + "\n");
	ShowPrompt( "Number: " + employee.empNumber + "\n");
	ShowPrompt( "Hours worked: " + employee.hours + "\n");
	ShowPrompt( "Hourly payRate: " + employee.payRate.ToString("n2") + "\n");
	
	ShowPrompt( "\n\nGross Pay: $" + employee.grossPay.ToString("n2") + "\n");
	
	Console::ReadKey ();

	return 0;
}

//---HELPER FUNCTIONS TO GET/DISPLAY USER INPUTS
void ShowPrompt (String^ msg)
	{
		return Console::Write (msg);
		
	}

double get$ ()
	{
	return Convert::ToDouble (Console::ReadLine ());


	}